Blame


1 0e673013 2019-01-02 stsp #!/bin/sh
2 0e673013 2019-01-02 stsp #
3 5aa81393 2020-01-06 stsp # Copyright (c) 2019, 2020 Stefan Sperling <stsp@openbsd.org>
4 0e673013 2019-01-02 stsp #
5 0e673013 2019-01-02 stsp # Permission to use, copy, modify, and distribute this software for any
6 0e673013 2019-01-02 stsp # purpose with or without fee is hereby granted, provided that the above
7 0e673013 2019-01-02 stsp # copyright notice and this permission notice appear in all copies.
8 0e673013 2019-01-02 stsp #
9 0e673013 2019-01-02 stsp # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 0e673013 2019-01-02 stsp # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 0e673013 2019-01-02 stsp # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 0e673013 2019-01-02 stsp # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 0e673013 2019-01-02 stsp # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 0e673013 2019-01-02 stsp # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 0e673013 2019-01-02 stsp # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
16 0e673013 2019-01-02 stsp
17 f81387ac 2023-02-17 thomas regress_run_only=""
18 f81387ac 2023-02-17 thomas
19 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_NAME="Flan Hacker"
20 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_EMAIL="flan_hacker@openbsd.org"
21 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_NAME="$GIT_AUTHOR_NAME"
22 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_EMAIL="$GIT_AUTHOR_EMAIL"
23 0b2899f8 2019-08-18 stsp export GOT_AUTHOR="$GIT_AUTHOR_NAME <$GIT_AUTHOR_EMAIL>"
24 82f6abb8 2019-08-14 stsp export GOT_AUTHOR_8="flan_hac"
25 e600f124 2021-03-21 stsp export GOT_AUTHOR_11="flan_hacker"
26 b1ebc001 2019-08-13 stsp export GOT_LOG_DEFAULT_LIMIT=0
27 11f4fa81 2020-10-01 stsp export GOT_TEST_ROOT="/tmp"
28 1f240092 2022-07-24 thomas export GOT_IGNORE_GITCONFIG=1
29 113392cf 2023-01-23 thomas export GOT_VERSION_STR=`got --version | cut -d ' ' -f2`
30 c3754a5b 2019-05-10 stsp
31 7b67836a 2019-05-10 stsp export MALLOC_OPTIONS=S
32 d3b82051 2022-07-10 thomas
33 d3b82051 2022-07-10 thomas # Check to see if PLATFORM has a value. PLATFORM is populated when running
34 d3b82051 2022-07-10 thomas # via `./configure && make` but this isn't guaranteed if an individual test is
35 d3b82051 2022-07-10 thomas # run directly, such as `regress/cmdline/tag.sh`. In such cases, PLATFORM
36 d3b82051 2022-07-10 thomas # will be empty, but we still want to use it. Since we test for non-linux
37 d3b82051 2022-07-10 thomas # values, only set PLATFORM if we're running on Linu so that the correct
38 d3b82051 2022-07-10 thomas # commands are used.
39 980b1615 2022-07-11 thomas [ -z "$PLATFORM" -a "$(uname)" = "Linux" ] && PLATFORM="linux"
40 7b67836a 2019-05-10 stsp
41 fa37079f 2021-10-09 thomas date()
42 fa37079f 2021-10-09 thomas {
43 fa37079f 2021-10-09 thomas DATECMD="date"
44 e8da6c41 2022-07-10 thomas [ "$PLATFORM" != "linux" ] && {
45 e8da6c41 2022-07-10 thomas command -v "gdate" >/dev/null 2>&1 && {
46 e8da6c41 2022-07-10 thomas DATECMD="gdate"
47 e8da6c41 2022-07-10 thomas } || {
48 cc5596d8 2022-07-11 thomas echo "Couldn't find gdate is GNU coreutils installed?"
49 e8da6c41 2022-07-10 thomas }
50 e8da6c41 2022-07-10 thomas }
51 c206b220 2021-10-09 thomas command "$DATECMD" "$@"
52 fa37079f 2021-10-09 thomas }
53 fa37079f 2021-10-09 thomas
54 fa37079f 2021-10-09 thomas ln()
55 fa37079f 2021-10-09 thomas {
56 fa37079f 2021-10-09 thomas LNCMD="ln"
57 e8da6c41 2022-07-10 thomas [ "$PLATFORM" != "linux" ] && {
58 e8da6c41 2022-07-10 thomas command -v "gln" >/dev/null 2>&1 && {
59 e8da6c41 2022-07-10 thomas LNCMD="gln"
60 e8da6c41 2022-07-10 thomas } || {
61 cc5596d8 2022-07-11 thomas echo "Couldn't find gln is GNU coreutils installed?"
62 e8da6c41 2022-07-10 thomas }
63 e8da6c41 2022-07-10 thomas }
64 c206b220 2021-10-09 thomas command "$LNCMD" "$@"
65 fa37079f 2021-10-09 thomas }
66 fa37079f 2021-10-09 thomas
67 c206b220 2021-10-09 thomas sed()
68 c206b220 2021-10-09 thomas {
69 c206b220 2021-10-09 thomas SEDCMD="sed"
70 186c23b6 2022-03-08 thomas
71 186c23b6 2022-03-08 thomas # On non-linux systems, the sed command can happily accept "-i ''" as
72 186c23b6 2022-03-08 thomas # a valid command to not save backup files for in-place edits.
73 186c23b6 2022-03-08 thomas # However, on linux, "-i ''" would be treated as "-i" with a blank
74 186c23b6 2022-03-08 thomas # argument, and hence, no file to edit in-place, which is an error.
75 186c23b6 2022-03-08 thomas #
76 186c23b6 2022-03-08 thomas # Therefore, scan the argument list and remove "-i ''", replacing it
77 186c23b6 2022-03-08 thomas # with just "-i".
78 432c637b 2022-07-11 thomas
79 1ff9fea4 2021-11-23 thomas [ "$PLATFORM" = "linux" ] && {
80 432c637b 2022-07-11 thomas for w in "$@"
81 432c637b 2022-07-11 thomas do
82 432c637b 2022-07-11 thomas [ "$w" = "-i" ] && {
83 432c637b 2022-07-11 thomas seen=1
84 432c637b 2022-07-11 thomas continue
85 432c637b 2022-07-11 thomas }
86 432c637b 2022-07-11 thomas
87 432c637b 2022-07-11 thomas [ "$seen" = "1" -a -z "$w" ] && {
88 432c637b 2022-07-11 thomas # Move past -i and ''
89 186c23b6 2022-03-08 thomas shift 2
90 432c637b 2022-07-11 thomas
91 0a046396 2022-07-12 thomas command "$SEDCMD" -i "$@"
92 186c23b6 2022-03-08 thomas return
93 186c23b6 2022-03-08 thomas }
94 186c23b6 2022-03-08 thomas done
95 c206b220 2021-10-09 thomas }
96 0a046396 2022-07-12 thomas command "$SEDCMD" "$@"
97 c206b220 2021-10-09 thomas }
98 fa37079f 2021-10-09 thomas
99 fa37079f 2021-10-09 thomas
100 f6cae3ed 2020-09-13 naddy git_init()
101 0e673013 2019-01-02 stsp {
102 0b2899f8 2019-08-18 stsp git init -q "$1"
103 f60607c8 2021-09-30 thomas
104 f60607c8 2021-09-30 thomas # Switch the default branch to match our test expectations if needed.
105 f60607c8 2021-09-30 thomas # Only need to change HEAD since 'git init' did not create any refs.
106 f60607c8 2021-09-30 thomas # Relying on implementation details of 'git init' is no problem for us.
107 f60607c8 2021-09-30 thomas # We want to be alerted when Git changes fundamental assumptions such
108 f60607c8 2021-09-30 thomas # as what an empty repository looks like and where the default branch
109 f60607c8 2021-09-30 thomas # is set. In such cases Got's own tooling might well need to change
110 f60607c8 2021-09-30 thomas # its behaviour, too, and our tests should fail.
111 f60607c8 2021-09-30 thomas # TODO: Update all tests to assume 'main' instead of 'master' and
112 f60607c8 2021-09-30 thomas # switch to main here, to match Got's own default.
113 f60607c8 2021-09-30 thomas echo "ref: refs/heads/master" > "$1/.git/HEAD"
114 0e673013 2019-01-02 stsp }
115 0e673013 2019-01-02 stsp
116 f6cae3ed 2020-09-13 naddy maybe_pack_repo()
117 b32c4525 2020-01-05 stsp {
118 b32c4525 2020-01-05 stsp local repo="$1"
119 b32c4525 2020-01-05 stsp if [ -n "$GOT_TEST_PACK" ]; then
120 a628577a 2023-02-17 thomas arg=""
121 a628577a 2023-02-17 thomas if [ "$GOT_TEST_PACK" = "ref-delta" ]; then
122 a628577a 2023-02-17 thomas arg="-D"
123 a628577a 2023-02-17 thomas fi
124 a628577a 2023-02-17 thomas
125 a628577a 2023-02-17 thomas (cd $repo && gotadmin pack -a $arg > /dev/null)
126 a628577a 2023-02-17 thomas (cd $repo && gotadmin cleanup -a -q)
127 b32c4525 2020-01-05 stsp fi
128 b32c4525 2020-01-05 stsp }
129 b32c4525 2020-01-05 stsp
130 f6cae3ed 2020-09-13 naddy git_commit()
131 0e673013 2019-01-02 stsp {
132 0e673013 2019-01-02 stsp local repo="$1"
133 0e673013 2019-01-02 stsp shift
134 0b2899f8 2019-08-18 stsp (cd $repo && git commit --author="$GOT_AUTHOR" -q -a "$@")
135 b32c4525 2020-01-05 stsp maybe_pack_repo $repo
136 0e673013 2019-01-02 stsp }
137 0e673013 2019-01-02 stsp
138 f6cae3ed 2020-09-13 naddy git_rm()
139 512f0d0e 2019-01-02 stsp {
140 512f0d0e 2019-01-02 stsp local repo="$1"
141 512f0d0e 2019-01-02 stsp shift
142 512f0d0e 2019-01-02 stsp (cd $repo && git rm -q "$@")
143 512f0d0e 2019-01-02 stsp }
144 512f0d0e 2019-01-02 stsp
145 f6cae3ed 2020-09-13 naddy git_show_head()
146 9c4b8182 2019-01-02 stsp {
147 9c4b8182 2019-01-02 stsp local repo="$1"
148 9c4b8182 2019-01-02 stsp (cd $repo && git show --no-patch --pretty='format:%H')
149 9c4b8182 2019-01-02 stsp }
150 9c4b8182 2019-01-02 stsp
151 f6cae3ed 2020-09-13 naddy git_show_branch_head()
152 db32465d 2020-02-07 stsp {
153 db32465d 2020-02-07 stsp local repo="$1"
154 db32465d 2020-02-07 stsp local branch="$2"
155 db32465d 2020-02-07 stsp (cd $repo && git show --no-patch --pretty='format:%H' $branch)
156 db32465d 2020-02-07 stsp }
157 db32465d 2020-02-07 stsp
158 db32465d 2020-02-07 stsp
159 f6cae3ed 2020-09-13 naddy git_show_author_time()
160 bcb49d15 2019-08-14 stsp {
161 bcb49d15 2019-08-14 stsp local repo="$1"
162 01073a5d 2019-08-22 stsp local object="$2"
163 01073a5d 2019-08-22 stsp (cd $repo && git show --no-patch --pretty='format:%at' $object)
164 bcb49d15 2019-08-14 stsp }
165 bcb49d15 2019-08-14 stsp
166 f6cae3ed 2020-09-13 naddy git_show_tagger_time()
167 8e7bd50a 2019-08-22 stsp {
168 8e7bd50a 2019-08-22 stsp local repo="$1"
169 8e7bd50a 2019-08-22 stsp local tag="$2"
170 8e7bd50a 2019-08-22 stsp (cd $repo && git cat-file tag $tag | grep ^tagger | \
171 8e7bd50a 2019-08-22 stsp sed -e "s/^tagger $GOT_AUTHOR//" | cut -d' ' -f2)
172 8e7bd50a 2019-08-22 stsp }
173 8e7bd50a 2019-08-22 stsp
174 f6cae3ed 2020-09-13 naddy git_show_parent_commit()
175 818c7501 2019-07-11 stsp {
176 818c7501 2019-07-11 stsp local repo="$1"
177 70551d57 2020-04-24 stsp local commit="$2"
178 70551d57 2020-04-24 stsp (cd $repo && git show --no-patch --pretty='format:%P' $commit)
179 818c7501 2019-07-11 stsp }
180 818c7501 2019-07-11 stsp
181 f6cae3ed 2020-09-13 naddy git_show_tree()
182 03415a1a 2019-06-02 stsp {
183 03415a1a 2019-06-02 stsp local repo="$1"
184 03415a1a 2019-06-02 stsp (cd $repo && git show --no-patch --pretty='format:%T')
185 03415a1a 2019-06-02 stsp }
186 03415a1a 2019-06-02 stsp
187 f6cae3ed 2020-09-13 naddy trim_obj_id()
188 818c7501 2019-07-11 stsp {
189 9439a990 2020-09-16 naddy local trimcount=$1
190 9439a990 2020-09-16 naddy local id=$2
191 818c7501 2019-07-11 stsp
192 9439a990 2020-09-16 naddy local pat=""
193 9439a990 2020-09-16 naddy while [ "$trimcount" -gt 0 ]; do
194 818c7501 2019-07-11 stsp pat="[0-9a-f]$pat"
195 9439a990 2020-09-16 naddy trimcount=$((trimcount - 1))
196 818c7501 2019-07-11 stsp done
197 818c7501 2019-07-11 stsp
198 818c7501 2019-07-11 stsp echo ${id%$pat}
199 818c7501 2019-07-11 stsp }
200 818c7501 2019-07-11 stsp
201 f6cae3ed 2020-09-13 naddy git_commit_tree()
202 03415a1a 2019-06-02 stsp {
203 03415a1a 2019-06-02 stsp local repo="$1"
204 03415a1a 2019-06-02 stsp local msg="$2"
205 03415a1a 2019-06-02 stsp local tree="$3"
206 03415a1a 2019-06-02 stsp (cd $repo && git commit-tree -m "$msg" "$tree")
207 03415a1a 2019-06-02 stsp }
208 03415a1a 2019-06-02 stsp
209 f0fd0aaf 2021-09-14 stsp git_fsck()
210 f0fd0aaf 2021-09-14 stsp {
211 f0fd0aaf 2021-09-14 stsp local testroot="$1"
212 f0fd0aaf 2021-09-14 stsp local repo="$2"
213 f0fd0aaf 2021-09-14 stsp
214 f0fd0aaf 2021-09-14 stsp (cd $repo && git fsck --strict \
215 f0fd0aaf 2021-09-14 stsp > $testroot/fsck.stdout 2> $testroot/fsck.stderr)
216 fc414659 2022-04-16 thomas ret=$?
217 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
218 f0fd0aaf 2021-09-14 stsp echo -n "git fsck: "
219 f0fd0aaf 2021-09-14 stsp cat $testroot/fsck.stderr
220 f0fd0aaf 2021-09-14 stsp echo "git fsck failed; leaving test data in $testroot"
221 f0fd0aaf 2021-09-14 stsp return 1
222 f0fd0aaf 2021-09-14 stsp fi
223 f0fd0aaf 2021-09-14 stsp
224 f0fd0aaf 2021-09-14 stsp return 0
225 f0fd0aaf 2021-09-14 stsp }
226 f0fd0aaf 2021-09-14 stsp
227 f6cae3ed 2020-09-13 naddy make_test_tree()
228 0e673013 2019-01-02 stsp {
229 0e673013 2019-01-02 stsp repo="$1"
230 0e673013 2019-01-02 stsp
231 0e673013 2019-01-02 stsp echo alpha > $repo/alpha
232 0e673013 2019-01-02 stsp echo beta > $repo/beta
233 0e673013 2019-01-02 stsp mkdir $repo/gamma
234 0e673013 2019-01-02 stsp echo delta > $repo/gamma/delta
235 0e673013 2019-01-02 stsp mkdir $repo/epsilon
236 0e673013 2019-01-02 stsp echo zeta > $repo/epsilon/zeta
237 0e673013 2019-01-02 stsp }
238 0e673013 2019-01-02 stsp
239 f6cae3ed 2020-09-13 naddy make_single_file_repo()
240 e7303626 2020-05-14 stsp {
241 e7303626 2020-05-14 stsp repo="$1"
242 e7303626 2020-05-14 stsp file="$2"
243 e7303626 2020-05-14 stsp
244 e7303626 2020-05-14 stsp mkdir $repo
245 e7303626 2020-05-14 stsp git_init $repo
246 e7303626 2020-05-14 stsp echo "this is file $file" > $repo/$file
247 e7303626 2020-05-14 stsp (cd $repo && git add .)
248 e7303626 2020-05-14 stsp git_commit $repo -m "intialize $repo with file $file"
249 e7303626 2020-05-14 stsp }
250 e7303626 2020-05-14 stsp
251 f6cae3ed 2020-09-13 naddy get_loose_object_path()
252 e7303626 2020-05-14 stsp {
253 e7303626 2020-05-14 stsp local repo="$1"
254 e7303626 2020-05-14 stsp local id="$2"
255 e7303626 2020-05-14 stsp local id0=`trim_obj_id 38 $id`
256 e7303626 2020-05-14 stsp local idrest=`echo ${id#[0-9a-f][0-9a-f]}`
257 e7303626 2020-05-14 stsp echo "$repo/.git/objects/$id0/$idrest"
258 e7303626 2020-05-14 stsp }
259 e7303626 2020-05-14 stsp
260 f6cae3ed 2020-09-13 naddy get_blob_id()
261 3ce1b845 2019-07-15 stsp {
262 3ce1b845 2019-07-15 stsp repo="$1"
263 3ce1b845 2019-07-15 stsp tree_path="$2"
264 3ce1b845 2019-07-15 stsp filename="$3"
265 3ce1b845 2019-07-15 stsp
266 e8863bdc 2020-07-23 stsp got tree -r $repo -i $tree_path | grep "[0-9a-f] ${filename}$" | \
267 e8863bdc 2020-07-23 stsp cut -d' ' -f 1
268 3ce1b845 2019-07-15 stsp }
269 3ce1b845 2019-07-15 stsp
270 f6cae3ed 2020-09-13 naddy test_init()
271 0e673013 2019-01-02 stsp {
272 0e673013 2019-01-02 stsp local testname="$1"
273 4a1ddfc2 2019-01-12 stsp local no_tree="$2"
274 0e673013 2019-01-02 stsp if [ -z "$testname" ]; then
275 0e673013 2019-01-02 stsp echo "No test name provided" >&2
276 0e673013 2019-01-02 stsp return 1
277 0e673013 2019-01-02 stsp fi
278 e5a14fe3 2020-10-01 stsp local testroot=`mktemp -d "$GOT_TEST_ROOT/got-test-$testname-XXXXXXXX"`
279 0e673013 2019-01-02 stsp mkdir $testroot/repo
280 0e673013 2019-01-02 stsp git_init $testroot/repo
281 4a1ddfc2 2019-01-12 stsp if [ -z "$no_tree" ]; then
282 4a1ddfc2 2019-01-12 stsp make_test_tree $testroot/repo
283 3ce1b845 2019-07-15 stsp (cd $repo && git add .)
284 4a1ddfc2 2019-01-12 stsp git_commit $testroot/repo -m "adding the test tree"
285 4a1ddfc2 2019-01-12 stsp fi
286 c8c71e6e 2020-03-21 stsp touch $testroot/repo/.git/git-daemon-export-ok
287 0e673013 2019-01-02 stsp echo "$testroot"
288 0e673013 2019-01-02 stsp }
289 0e673013 2019-01-02 stsp
290 f6cae3ed 2020-09-13 naddy test_cleanup()
291 0e673013 2019-01-02 stsp {
292 0e673013 2019-01-02 stsp local testroot="$1"
293 fe7842f5 2019-07-14 stsp
294 f0fd0aaf 2021-09-14 stsp git_fsck $testroot $testroot/repo
295 fc414659 2022-04-16 thomas ret=$?
296 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
297 f0fd0aaf 2021-09-14 stsp return $ret
298 fe7842f5 2019-07-14 stsp fi
299 fe7842f5 2019-07-14 stsp
300 0e673013 2019-01-02 stsp rm -rf "$testroot"
301 0e673013 2019-01-02 stsp }
302 0e673013 2019-01-02 stsp
303 f6cae3ed 2020-09-13 naddy test_parseargs()
304 7fb414ae 2020-08-08 stsp {
305 6c8da0c6 2020-10-03 naddy while getopts qr: flag; do
306 6c8da0c6 2020-10-03 naddy case $flag in
307 6c8da0c6 2020-10-03 naddy q) export GOT_TEST_QUIET=1
308 6c8da0c6 2020-10-03 naddy ;;
309 4f3c3d1e 2023-01-10 thomas r) export GOT_TEST_ROOT=${OPTARG%/}
310 6c8da0c6 2020-10-03 naddy ;;
311 6c8da0c6 2020-10-03 naddy ?) echo "Supported options:"
312 6c8da0c6 2020-10-03 naddy echo " -q: quiet mode"
313 6c8da0c6 2020-10-03 naddy echo " -r PATH: use PATH as test data root directory"
314 6c8da0c6 2020-10-03 naddy exit 2
315 6c8da0c6 2020-10-03 naddy ;;
316 7fb414ae 2020-08-08 stsp esac
317 7fb414ae 2020-08-08 stsp done
318 f81387ac 2023-02-17 thomas shift $(($OPTIND - 1))
319 f81387ac 2023-02-17 thomas regress_run_only="$@"
320 6c8da0c6 2020-10-03 naddy } >&2
321 7fb414ae 2020-08-08 stsp
322 f6cae3ed 2020-09-13 naddy run_test()
323 0e673013 2019-01-02 stsp {
324 0e673013 2019-01-02 stsp testfunc="$1"
325 f81387ac 2023-02-17 thomas
326 f81387ac 2023-02-17 thomas if [ -n "$regress_run_only" ]; then
327 f81387ac 2023-02-17 thomas case "$regress_run_only" in
328 f81387ac 2023-02-17 thomas *$testfunc*) ;;
329 f81387ac 2023-02-17 thomas *) return ;;
330 f81387ac 2023-02-17 thomas esac
331 f81387ac 2023-02-17 thomas fi
332 f81387ac 2023-02-17 thomas
333 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
334 7fb414ae 2020-08-08 stsp echo -n "$testfunc "
335 7fb414ae 2020-08-08 stsp fi
336 0e673013 2019-01-02 stsp $testfunc
337 0e673013 2019-01-02 stsp }
338 0e673013 2019-01-02 stsp
339 f6cae3ed 2020-09-13 naddy test_done()
340 0e673013 2019-01-02 stsp {
341 0e673013 2019-01-02 stsp local testroot="$1"
342 0e673013 2019-01-02 stsp local result="$2"
343 54c39596 2020-12-28 stsp if [ "$result" = "0" ]; then
344 fe7842f5 2019-07-14 stsp test_cleanup "$testroot" || return 1
345 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
346 7fb414ae 2020-08-08 stsp echo "ok"
347 7fb414ae 2020-08-08 stsp fi
348 3941b73a 2019-05-14 stsp elif echo "$result" | grep -q "^xfail"; then
349 3941b73a 2019-05-14 stsp # expected test failure; test reproduces an unfixed bug
350 3941b73a 2019-05-14 stsp echo "$result"
351 17201126 2019-07-14 stsp test_cleanup "$testroot" || return 1
352 0e673013 2019-01-02 stsp else
353 0e673013 2019-01-02 stsp echo "test failed; leaving test data in $testroot"
354 0e673013 2019-01-02 stsp fi
355 0e673013 2019-01-02 stsp }